#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#if defined(WIN32)
//#  pragma comment(linker, "/subsystem:\"windows\" /entry:\"mainCRTStartup\"")
#  include "glut.h"
#  include "glext.h"
#elif defined(__APPLE__) || defined(MACOSX)
#  include <GLUT/glut.h>
#else
#  include <GL/glut.h>
#endif

/*
** 
*/
static const GLfloat lightpos[] = { 4.0, 5.0, 6.0, 1.0 }; /* ʒu@@@ */
static const GLfloat lightcol[] = { 1.0, 1.0, 1.0, 1.0 }; /* ڌx */
static const GLfloat lightamb[] = { 0.1, 0.1, 0.1, 1.0 }; /* x */

/*
** eNX`
*/
#define TEXWIDTH  128                       /* eNX`̕@@@@@ */
#define TEXHEIGHT 128                       /* eNX`̍@@@@ */
static const struct {
  GLenum name;                              /* eNX`̃^[Qbg */
  GLint x, y;                               /* r[|[g̈ʒu@@@ */
  GLdouble cx, cy, cz;                      /* ̌@@@@@@@ */
  GLdouble ux, uy, uz;                      /* uv̕@@@@@@ */
} target[] = {
  { /*  */
    GL_TEXTURE_CUBE_MAP_NEGATIVE_X,
    0, TEXHEIGHT,
    1.0, 0.0, 0.0,
    0.0, 1.0, 0.0,
  },
  { /* O */
    GL_TEXTURE_CUBE_MAP_POSITIVE_Z,
    TEXWIDTH, TEXHEIGHT,
    0.0, 0.0, 1.0,
    0.0, 1.0, 0.0,
  },
  { /* E */
    GL_TEXTURE_CUBE_MAP_POSITIVE_X,
    TEXWIDTH * 2, TEXHEIGHT,
    -1.0, 0.0, 0.0,
    0.0, 1.0, 0.0,
  },
  { /*  */
    GL_TEXTURE_CUBE_MAP_NEGATIVE_Z,
    TEXWIDTH * 3, TEXHEIGHT,
    0.0, 0.0, -1.0,
    0.0, 1.0, 0.0,
  },
  { /*  */
    GL_TEXTURE_CUBE_MAP_NEGATIVE_Y,
    TEXWIDTH, TEXHEIGHT * 2,
    0.0, 1.0, 0.0,
    0.0, 0.0, -1.0,
  },
  { /*  */
    GL_TEXTURE_CUBE_MAP_POSITIVE_Y,
    TEXWIDTH, 0,
    0.0, -1.0, 0.0,
    0.0, 0.0, 1.0,
  },
};

/*
** 
*/
#define MAXSTARS 200
static GLuint stars;

/*
** EBhETCY
*/
static GLsizei width, height;

/*
** 
*/
static void init(void)
{
  int i;
  
  for (i = 0; i < 6; ++i) {
    /* eNX`̊蓖 */
    glTexImage2D(target[i].name, 0, GL_RGBA, TEXWIDTH, TEXHEIGHT, 0,
      GL_RGBA, GL_UNSIGNED_BYTE, 0);
  }
  
  /* eNX`gEk@̎w */
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
  
  /* eNX`̌JԂ@̎w */
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_S, GL_CLAMP_TO_EDGE);
  glTexParameteri(GL_TEXTURE_CUBE_MAP, GL_TEXTURE_WRAP_T, GL_CLAMP_TO_EDGE);
  
  /* eNX` */
  glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
  
  /* L[u}bsOp̃eNX`W𐶐 */
  glTexGeni(GL_S, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  glTexGeni(GL_T, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  glTexGeni(GL_R, GL_TEXTURE_GEN_MODE, GL_REFLECTION_MAP);
  
  /* ݒ */
  glClearColor(0.3, 0.3, 1.0, 1.0);
  glEnable(GL_DEPTH_TEST);
  glDisable(GL_CULL_FACE);
  
  /* ̏ݒ */
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, lightcol);
  glLightfv(GL_LIGHT0, GL_SPECULAR, lightcol);
  glLightfv(GL_LIGHT0, GL_AMBIENT, lightamb);
  
  /* ̐ */
  stars = glGenLists(1);
  glNewList(stars, GL_COMPILE);
#if 1
  /* ƂĔς` */
  for (i = 0; i < MAXSTARS; ++i) {
    float r = 2.5f * (float)rand() / (float)RAND_MAX + 2.5f;
    float t = 6.2831853f * (float)rand() / (float)RAND_MAX;
    float p = 3.1415926f * (float)rand() / (float)RAND_MAX;
    float c[] = {
      0.9f * (float)rand() / (float)RAND_MAX + 0.1f,
      0.9f * (float)rand() / (float)RAND_MAX + 0.1f,
      0.9f * (float)rand() / (float)RAND_MAX + 0.1f,
    };
    
    glPushMatrix();
    glMaterialfv(GL_FRONT_AND_BACK, GL_AMBIENT_AND_DIFFUSE, c);
    glTranslatef(r * sinf(p) * cosf(t), r * cosf(p), r * sinf(p) * sinf(t));
    glScalef(0.5f, 0.5f, 0.5f);
    glutSolidCube(0.8);
    glPopMatrix();
  }
#else
  /* ƂĔP` */
  glPushMatrix();
  glTranslated(0.0, 0.0, 3.0);
  glutSolidCube(1.0);
  glPopMatrix();
#endif
  glEndList();
}

/*
** V[̕`
*/
static void scene(void)
{
  static const GLfloat color[] = { 1.0, 1.0, 1.0, 1.0 };  /* ގ (F) */
  
  /* ̕` */
  glCallList(stars);

  /* ގ̐ݒ */
  glMaterialfv(GL_FRONT, GL_AMBIENT_AND_DIFFUSE, color);

  /* eNX`}bsOJn */
  glEnable(GL_TEXTURE_CUBE_MAP);
  
  /* eNX`W̎Lɂ */
  glEnable(GL_TEXTURE_GEN_S);
  glEnable(GL_TEXTURE_GEN_T);
  glEnable(GL_TEXTURE_GEN_R);

#if 1
  /* eB[|bg` */
  glutSolidTeapot(1.8);
#else
  /* ` */
  glutSolidSphere(1.5, 32, 16);
#endif
  
  /* eNX`W̎𖳌ɂ */
  glDisable(GL_TEXTURE_GEN_S);
  glDisable(GL_TEXTURE_GEN_T);
  glDisable(GL_TEXTURE_GEN_R);
  
  /* eNX`}bsOI */
  glDisable(GL_TEXTURE_CUBE_MAP);
}


/****************************
** GLUT ̃R[obN֐ **
****************************/

/* gbN{[p֐̐錾 */
#include "trackball.h"

static void display(void)
{
  /* ʃNA */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* ϊs̐ݒ */
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(90.0, 1.0, 1.0, 10.0);
  
  /* fr[ϊs̐ݒ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* eNX`̍쐬 */
  for (int i = 0; i < 6; ++i) {
    /* r[|[geNX`̃TCYɐݒ肷 */
    glViewport(target[i].x, target[i].y, TEXWIDTH, TEXHEIGHT);
    
    /* ̕ݒ肵āČɌ̂_O */
    glPushMatrix();
    gluLookAt(0.0, 0.0, 0.0,
      target[i].cx, target[i].cy, target[i].cz,
      target[i].ux, target[i].uy, target[i].uz);
    glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
    glMultMatrixd(trackballRotation());
    glCallList(stars);
    glPopMatrix();
    
    /* _OʂeNX`Ɉڂ */
    glCopyTexSubImage2D(target[i].name, 0, 0, 0,
      target[i].x, target[i].y, TEXWIDTH, TEXHEIGHT);
  }
  
  /* eNX`ϊs̐ݒ */
  glMatrixMode(GL_TEXTURE);
  glLoadIdentity();
  glScaled(-1.0, -1.0, 1.0);
  
#if 1
  /* ʃNA */
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
  
  /* EBhEŜr[|[gɂ */
  glViewport(0, 0, width, height);
  
  /* ϊs̎w */
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(60.0, (double)width / (double)height, 1.0, 100.0);
  
  /* fr[ϊs̐ݒ */
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  
  /* _̈ړî̕Ɉړj*/
  glTranslated(0.0, 0.0, -7.0);
  
  /* ̈ʒuݒ */
  glLightfv(GL_LIGHT0, GL_POSITION, lightpos);
  
  /* gbN{[ɂ] */
  glMultMatrixd(trackballRotation());
  
  /* V[̕` */
  scene();
#endif
  
  /* _uobt@O */
  glutSwapBuffers();
}

static void resize(int w, int h)
{
  /* EBhETCY̏k𐧌 */
  if (w < TEXWIDTH * 4 || h < TEXHEIGHT * 3) {
    if (w < TEXWIDTH * 4) w = TEXWIDTH * 4;
    if (h < TEXHEIGHT * 3) h = TEXHEIGHT * 3;
    glutReshapeWindow(w, h);
  }

  /* EBhETCY̕ۑ */
  width = w;
  height = h;

  /* gbN{[͈ */
  trackballRegion(w, h);
}

static void idle(void)
{
  /* ʂ̕`ւ */
  glutPostRedisplay();
}

static void mouse(int button, int state, int x, int y)
{
  switch (button) {
  case GLUT_LEFT_BUTTON:
    switch (state) {
    case GLUT_DOWN:
      /* gbN{[Jn */
      trackballStart(x, y);
      glutIdleFunc(idle);
      break;
    case GLUT_UP:
      /* gbN{[~ */
      trackballStop(x, y);
      glutIdleFunc(0);
      break;
    default:
      break;
    }
    break;
    default:
      break;
  }
}

static void motion(int x, int y)
{
  /* gbN{[ړ */
  trackballMotion(x, y);
}

static void keyboard(unsigned char key, int x, int y)
{
  switch (key) {
  case 'q':
  case 'Q':
  case '\033':
    /* ESC  q  Q ^CvI */
    exit(0);
  default:
    break;
  }
}

/*
** CvO
*/
int main(int argc, char *argv[])
{
  glutInit(&argc, argv);
  glutInitWindowSize(TEXWIDTH * 4, TEXWIDTH * 3);
  glutInitDisplayMode(GLUT_RGBA | GLUT_DEPTH | GLUT_DOUBLE);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(display);
  glutReshapeFunc(resize);
  glutMouseFunc(mouse);
  glutMotionFunc(motion);
  glutKeyboardFunc(keyboard);
  init();
  glutMainLoop();
  return 0;
}
